<template>
  <BasicModal
    v-bind="$attrs"
    @register="register"
    title="相机授权"
    @visible-change="handleVisibleChange"
    @cancel="resetFields"
    @ok="handleConfirm"
  >
    <div class="pt-2px pr-3px zdysrk">
      <BasicForm @register="registerForm">
        <template #text="{ model, field }"> {{ model[field] }}{{ fileFlow.type }} </template>
      </BasicForm>
    </div>
  </BasicModal>
</template>
<script lang="ts">
  import { defineComponent, nextTick, onMounted, reactive, computed, h } from 'vue';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, FormSchema, useForm } from '/@/components/Form/index';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { remarkschemas, Addschemas } from './data';
  import { InvoiceRegister } from '/@/api/order';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { uploadApi } from '/@/api/product/index';
  import { ResultEnum } from '/@/enums/httpEnum';
  import { authorizeCameraaddOrUpdate } from '/@/api/authorizeModeling';
  import dayjs from 'dayjs';
  import { otherInfoStore } from '/@/store/modules/other';

  const { t } = useI18n();
  export default defineComponent({
    components: { BasicModal, BasicForm },
    props: {
      userData: { type: Object },
    },
    emits: ['update', 'register'],
    setup(props, { emit }) {
      const otherInfo = otherInfoStore();
      const overviewInfo = computed(() => otherInfo.getOverviewInfo);
      // const overviewInfo = getOverviewInfo() || {}
      const fileFlow = reactive({
        file: null,
        id: '',
        type: 'down', //down-下载，equity-权益
      });
      const { createMessage, createConfirm, createSuccessModal } = useMessage();
      const schemas: FormSchema[] = [
        {
          field: 'id',
          component: 'Input',
          show: false,
          label: 'id',
        },
        {
          field: 'machineCode',
          component: 'InputTextArea',
          required: true,
          componentProps: {
            rows: 4,
          },
          label: '机器码',
          colProps: { span: 20 },
        },
        {
          field: 'snCodes',
          component: 'InputTextArea',
          required: true,
          label: '授权SN码',
          componentProps: {
            placeholder: '请输入授权SN码，多个sn码换行输入',
            rows: 4,
          },
          colProps: { span: 20 },
        },
      ];

      const [registerForm, { validate, resetFields, setFieldsValue, updateSchema }] = useForm({
        labelWidth: 120,
        schemas: [...Addschemas, ...schemas, ...remarkschemas],
        showActionButtonGroup: false,
        actionColOptions: {
          span: 24,
        },
      });
      onMounted(() => {});
      let addListFunc = () => {};
      const [register, { closeModal }] = useModalInner((data) => {
        data && onDataReceive(data);
      });
      async function onDataReceive(data) {
        resetFields();
        fileFlow.id = data.id;
        updateSchema([
          {
            field: 'useType',
            componentProps: {
              onChange: (value) => {
                updateSchema({ field: 'projectNum', ifShow: value == '4' });
              },
            },
          },
          {
            field: 'projectNum',
            ifShow: data.useType == '4',
          },
        ]);
        setFieldsValue(data);
      }
      async function handleConfirm() {
        const { id } = await validate();
        createConfirm({
          iconType: 'warning',
          title: () => h('span', '温馨提示'),
          content: () => h('span', `确定要${id ? '编辑' : '新增'}授权吗？`),
          onOk: async () => {
            handleSubmit();
          },
        });
      }
      const handleSubmit = async () => {
        try {
          const params = await validate();
          // let authorizeTime = params.authorizeTime.split('_');
          const apiData = {
            ...params,
            userId: params.id,
            // authorizeTime: authorizeTime[0],
            // authorizeTimeUnit: authorizeTime[1],
          };
          let res = await authorizeCameraaddOrUpdate(apiData);
          let count = (res.snCodes && res.snCodes.split('\n')) || [];
          closeModal();
          resetFields();
          createSuccessModal({
            title: t('layout.setting.operatingTitle'),
            content: h('div', {}, [
              h('p', `安装Key：${res.authorizeKey}`),
              h('p', `授权相机数量：${count.length}`),
            ]),
            okText: '复制授权Key',
            onOk: async () => {
              // 双击复制
              let save = function (e) {
                e.clipboardData.setData('text/plain', res.authorizeKey);
                e.preventDefault(); //阻止默认行为
              };
              document.addEventListener('copy', save); //添加一个copy事件
              document.execCommand('copy'); //执行copy方法
              createMessage.success('复制成功');
            },
          });
          // createMessage.success(t('common.optSuccess'));
          emit('update');
        } catch (error) {
          console.log('not passing', error);
        }
      };
      function handleVisibleChange(v) {
        v && props.userData && nextTick(() => onDataReceive(props.userData));
      }
      return {
        register,
        registerForm,
        fileFlow,
        handleVisibleChange,
        handleSubmit,
        addListFunc,
        resetFields,
        handleConfirm,
        t,
      };
    },
  });
</script>
<style lang="less">
  .zdysrk {
    .ant-calendar-picker {
      min-width: 285px;
    }
  }
</style>
